'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                Custom                                    |
'|                                                                          |
'|                          GDImage 5.05 project                            |
'|                                                                          |
'|    Creation of a mixed composited object using 2D and 3D animations.     |
'|                                                                          |
'|        Requires a graphic card that is OpenGL 2.00+ compatible.          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2009                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 06-10-2009 (MM-DD-YYYY)            |
'|                        Last revised : 06-12-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "Custom.exe"
#OPTION VERSION5

'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "ZSKIN.INC"

#INCLUDE "GDIMAGE.INC"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
'DECLARE FUNCTION zDebug LIB "zTrace.DLL" ALIAS "zDebug" (zMessage AS ASCIIZ) AS LONG

%VK_PRIOR                 = &H21
%VK_NEXT                  = &H22
%VK_END                   = &H23
%VK_HOME                  = &H24
%VK_LEFT                  = &H25
%VK_NUMPAD4               = &H64
%VK_UP                    = &H26
%VK_NUMPAD8               = &H68
%VK_RIGHT                 = &H27
%VK_NUMPAD6               = &H66
%VK_DOWN                  = &H28
%VK_NUMPAD2               = &H62

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------

%XMIN_SIZE              = 800 '// Window minimum width
%YMIN_SIZE              = 600 '// Window minimum height

%GL_SizeX               = 200'384 '// X size of the OpenGL object
%GL_SizeY               = 200'384 '// Y size of the OpenGL object
%TIMER_DELAY            = 40  '// Timer delay (animation speed)

%ID_BACKGROUND          = -999
%ID_CTRL                = -1

%IDS_BORDER             = 1
%IDS_3DOBJECT           = 3
%IDS_LENS               = 4
%IDS_ANIMATION          = 6
'%IDS_BOWL               = 7

%ID_GDIMAGE             = -9
%ID_FRAMEBUTTON         = -10
%ID_RESET               = -12

%ID_LIB_ZOOM            = -13
%ID_TRACK_ZOOM          = -14
%ID_LIB_ROTATION        = -15
%ID_TRACK_ROTATION      = -16
%ID_LIB_ALPHA           = -17
%ID_TRACK_ALPHA         = -18
%ID_LIB_BRIGHTNESS      = -19
%ID_TRACK_BRIGHTNESS    = -20
%ID_LIB_CONTRAST        = -21
%ID_TRACK_CONTRAST      = -22
%ID_LIB_RED             = -23
%ID_TRACK_RED           = -24
%ID_LIB_GREEN           = -25
%ID_TRACK_GREEN         = -26
%ID_LIB_BLUE            = -27
%ID_TRACK_BLUE          = -28
%ID_LIB_HUE             = -29
%ID_TRACK_HUE           = -30

%ID_BACK_LIST           = -36

%ID_BTN_ABOUT           = -37
%ID_STATUSBAR           = -38
%ID_STATUSTIP           = -39

%ID_BTN_BACKL           = -42
%ID_BTN_BACKR           = -43
%ID_LIB_BACK            = -44

%ID_CLOCK               = -45
%ID_BTN_HELP            = -46

%ID_COMPOSITED          = -47
%ID_STATUSMESSAGE       = -49

%ID_CAMERA              = -51
%ID_GRADATION           = -52
%ID_GLOSSY              = -53
%ID_REFLECTION          = -54
%ID_BLUE                = -55
%ID_RED                 = -56
%ID_ENLIGHTEN            = -57
%ID_BEVEL               = -58

%ID_ANIMATION           = -59

%ID_GEM                 = -61

GLOBAL gnCtrl, gMainWnd AS DWORD
GLOBAL gnFocusID AS LONG
GLOBAl grWasZoom AS SINGLE
GLOBAL gnWasAngle, gnWasAlpha, gnWasBrightness, gnWasContrast, gnWasRed, gnWasGreen, gnWasBlue, gnWasHue AS LONG
GLOBAL gnSeedAngle, gnPrevAngle AS LONG
GLOBAL mt() AS ZGLTEXTUREX

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

'SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
'    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
'    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
'END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL Item AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF Item > 0 THEN
       DECR Item
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, Item, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessage(hList, %LB_GETTEXT, Item, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

FUNCTION GetSetGLmemDC(BYVAL hDC AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasDC AS LONG
    IF RW THEN WasDC = hDC
    FUNCTION = WasDC
END FUNCTION
FUNCTION GLmemDC() AS LONG
    FUNCTION = GetSetGLmemDC(0, 0)
END FUNCTION

'// This is the place where we create all the sprites being used into the GDImage control
FUNCTION GDImageCreateSprite() AS LONG
    LOCAL rc AS RECT
    LOCAL rZoomValue AS SINGLE
    LOCAL hBitmap, nW, nH, nSizeX, nSizeY AS LONG
    LOCAL hMemDC AS LONG

    CALL GetClientRect(gnCtrl, rc)

'   // The animated Jumper sprite.
    hBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "space24.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, (508 - nH) \ 2, (536 - nH) \ 2, hBitmap, ZD_ColorARGB(255, 0), %IDS_ANIMATION, %ZS_HIDDEN)
    CALL ZD_SetObjectFrameCount(%IDS_ANIMATION, nW \ nH)
    CALL ZD_SetObjectFrameToUse(%IDS_ANIMATION, 1, %FALSE)
    CALL ZD_SetObjectAnchorMode(%IDS_ANIMATION, %ANCHOR_CENTER)


'   ///////////////////////////////////////
'   // Start of OpenGL section
'   // Create the OpenGL rendering context
    CALL GL_CreateContext(%GL_SizeX, %GL_SizeY)
'   // Create the initial OpenGL texture.
    DIM mt(1 TO 1) AS ZGLTEXTUREX
    mt(1).FullName = SK_FOLDER() + "Graduation.jpg": mt(1).ID = 1: mt(1).Square = 2
    CALL ZI_MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

'   // Create the memory DIB DC to render the OpenGL sprite animation.
    hMemDC = GL_CreateDrawingDC(%GL_SizeX, %GL_SizeY)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, (rc.nRight - %GL_SizeX) \ 2, (rc.nBottom - %GL_SizeY) \ 2, ZI_GetBitmapFromDC(hMemDC), ZD_ColorARGB(255, 0), %IDS_3DOBJECT, %ZS_VISIBLE)

    CALL ZD_SetObjectAnchorMode(%IDS_3DOBJECT, %ANCHOR_CENTER)
    CALL ZD_SetObjectLinked(%IDS_3DOBJECT, %IDS_3DOBJECT) '// [*] Linked object, see [**]
'   // End of OpenGL section
'   ///////////////////////////////////////

    CALL ZD_SetObjectLinked(%IDS_ANIMATION, %IDS_3DOBJECT) '// [*] Linked object, see [**]

'   // The static Lens sprite.
    hBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "LENS_Camera.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, (rc.nRight - nW) \ 2, (rc.nBottom - nH) \ 2, hBitmap, ZD_ColorARGB(255, 0), %IDS_LENS, %ZS_VISIBLE)
    CALL ZD_SetObjectAnchorMode(%IDS_LENS, %ANCHOR_CENTER)
    CALL ZD_SetObjectLinked(%IDS_LENS, %IDS_3DOBJECT)

'   // The static Border sprite
    hBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "LENS_Border.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl, (rc.nRight - nW) \ 2, (rc.nBottom - nH) \ 2, hBitmap, ZD_ColorARGB(255, 0), %IDS_BORDER, %ZS_VISIBLE)
    CALL ZD_SetObjectAnchorMode(%IDS_BORDER, %ANCHOR_CENTER)
    CALL ZD_SetObjectLinked(%IDS_BORDER, %IDS_3DOBJECT)

'   // The animated Bowl sprite. 
    'hBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Bowl12.png", nW, nH)
    'CALL ZD_DrawBitmapToCtrl(gnCtrl, rc.nRight - 100, 100, hBitmap, ZD_ColorARGB(255, 0), %IDS_BOWL, %ZS_HIDDEN)
    'CALL ZD_SetObjectFrameCount(%IDS_BOWL, nW \ nH)
    'CALL ZD_SetObjectFrameToUse(%IDS_BOWL, 1, %FALSE)
    'CALL ZD_SetObjectAnchorMode(%IDS_BORDER, %ANCHOR_CENTER)
    'CALL ZD_SetObjectZorder(%IDS_BOWL, %ZD_ORDER_BOTTOM)   '// Change Z-ORDER

'   // Make sure that the composited background is still at the bottom of z-order
    CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM)

'   // We put the GDImage focus on the %IDS_3DOBJECT
    CALL ZI_SetObjectFocusID(%IDS_3DOBJECT)
    gnFocusID = %IDS_3DOBJECT
'   // Reset all setting controls to their default values.
    CALL GDImageResetImage(gnCtrl, gnFocusID)

'   // Turn on, high quality display
    CALL UpdateQualityStatus(%TRUE)

    IF hMemDC THEN
       CALL GetSetGLmemDC(hMemDC, 1)
       FUNCTION = hMemDC
    END IF

END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZIMAGE3D"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MsgBox zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0 ' %WS_EX_LAYERED '// Let the OS take care of the region for us (Doesn't work on XP)
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.Name$
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN


          IF (dwExStyle AND %WS_EX_LAYERED) THEN '// Warning this doesn't work on XP (only on VISTA and Windows 7)
             CALL SetLayeredWindowAttributes(gMainWnd, RGB(255,0,255), 255, %LWA_ALPHA OR %LWA_COLORKEY)
          END IF

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "GlassSkin.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()

          CALL GDImageEnableEvents(gnCtrl)
          CALL GDImageBackground()

'         // This is the place where we create all the sprites being used into the GDImage control
          IF GDImageCreateSprite() THEN '// If we have been sucessful, then play the show...

'            // *************************************************
'            // Show main window
'            // Create region and paint controls to double buffer
'            // *************************************************
             CALL zShowMainWindow(0)

             CALL SetTimer(gMainWnd, 1, %TIMER_DELAY, %NULL)

             WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
                IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                   CALL TranslateMessage(Msg)
                   CALL DispatchMessage(Msg)
                END IF
             WEND

             CALL KillTimer(gMainWnd, 1)

             '// VERY IMPORTANT
             '// FreeUp the resources
             IF GLmemDC() THEN
                CALL DeleteObject(ZI_GetBitmapFromDC( GLmemDC() ))
                CALL DeleteDC( GLmemDC() )
             END IF
             CALL GL_DeleteContext(GL_GLDC() , GL_GLRC() )

             FUNCTION = msg.wParam

          END IF
       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Fill the bakground listbox
'// Warning: Currently only JPG files!
SUB DetectBackground()
    LOCAL hList, WashFind, hFind, BackgroundCount, nSelected AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zBackground AS ASCIIZ * %MAX_PATH
    LOCAL sBackgroundPath AS STRING
    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

'   // Size of the current active background image
    nActiveBackgroundSize = zsFileSize((SK_CENTERFORM()))

    sBackgroundPath = zsExePath() + "Background\"

    hList = zGetMainItem(%ID_BACK_LIST)
    CALL ListDeleteAll(hList)

    WashFind = MyFindFirstFile((sBackgroundPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sBackgroundPath + fd.cFileName: CALL CharLower(zTmp)
             IF INSTR(".jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR BackgroundCount
'                  // If same size, then we assume it is our current background...
                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    nSelected = ListFindString(hList, zBackground)
    CALL ListSelectPlus(hList, nSelected)

    IF BackgroundCount < 2 THEN
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)
    END IF

END SUB

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hCtrl, imgW, imgH AS LONG
    LOCAL sLabel, sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG
    LOCAL rw AS RECT

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   OpenGL section
'   Create the Visual graphic control
    vgW = 508: vgH = 536'57
    'vgW = 0: vgH = 0
    zClass =  $GDImageClassName ' $GLImageClassName
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = 0 '%WS_EX_STATICEDGE
    gnCtrl = CreateWindowEx(StyleEx&, _
                           zClass, _                  ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           128, _                     ' initial x position
                           41, _                      ' initial y position
                           vgW, _                     ' Calculate Window Width
                           vgH, _                     ' Calculate Window Height
                           gMainWnd, _                ' parent window handle
                           %ID_CTRL, _                ' ControlID
                           zsInstance(), _            ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Anchor the control to match the size of the parent window
    CALL zSetAnchorMode(gnCtrl, %ANCHOR_HEIGHT_WIDTH)
    
'   ___________________

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "GDImage.png"), "", 594+8, 40, 191, 56, %ID_GDIMAGE, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Panel.png"), "", 1, 41, 135, 538, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_HEIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Aero.png"), "", 627+8, 102, 158, 395, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

'   ___________________


    sLabel = "Zoom"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 135, 140, 15, %ID_LIB_ZOOM, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 148, 140, 14, %ID_TRACK_ZOOM, 500, 1500, 1000, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Magnification")

    sLabel = "Rotation"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 163, 140, 15, %ID_LIB_ROTATION, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 176, 140, 14, %ID_TRACK_ROTATION, 0, 360, 180, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Perform full 0-360 rotation")

    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 642+8, 195, 16, 47, %ID_TRACK_ALPHA, 255, 0, 255, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Opacity level")
    hCtrl = zStaticLabelEx(gMainWnd, "Alpha", 633+8, 248, 34, 16, %ID_LIB_ALPHA, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)

    hCtrl = zPushButtonEx(gMainWnd, (SK_FOLDER() + "BTN_Hover.png"), "", 690+8, 229, 32, 32, %ID_RESET, SK_BTNTEXTCOLOR(), 0, 0, (SK_FOLDER() + "Restore.png"))
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Restore to initial state")

    sLabel = "Brightness"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 294, 140, 15, %ID_LIB_BRIGHTNESS, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 307, 140, 14, %ID_TRACK_BRIGHTNESS, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup the brightness level")

    sLabel = "Contrast"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 322, 140, 15, %ID_LIB_CONTRAST, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 335, 140, 14, %ID_TRACK_CONTRAST, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup the contrast level")

    sLabel = "Red"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 350, 140, 15, %ID_LIB_RED, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 363, 140, 14, %ID_TRACK_RED, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup red color level")

    sLabel = "Green"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 378, 140, 15, %ID_LIB_GREEN, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 391, 140, 14, %ID_TRACK_GREEN, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup green color level")

    sLabel = "Blue"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 406, 140, 15, %ID_LIB_BLUE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 419, 140, 14, %ID_TRACK_BLUE, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup blue color level")

    sLabel = "Hue"
    hCtrl = zStaticLabelEx(gMainWnd, (sLabel), 633+8, 434, 140, 15, %ID_LIB_HUE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    hCtrl = zTrackbarEx(gMainWnd, (SK_FOLDER() + "BTN_Track.png"), 636+8, 447, 140, 14, %ID_TRACK_HUE, 1, 255, 127, SK_TRACKHICOLOR(), SK_PROGRESSCOLOR())
    CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Setup the hue level")


    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Left.png"), 678, 507, %ID_BTN_BACKL, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Previous background")
    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Right.png"), 716, 507, %ID_BTN_BACKR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Next background")
    hCtrl = zStaticLabelEx(gMainWnd, "", 642, 544, 144, 18, %ID_LIB_BACK, SK_BTNTEXTCOLOR(), %BS_LABEL_CENTER, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, gMainWnd, %ID_BACK_LIST, zsInstance(), BYVAL %NULL)
    CALL DetectBackground()

    hCtrl = zClockCtrl(gMainWnd, (SK_FOLDER() + "SmallClock.png"), 24, 70, 0, 0, %ID_CLOCK, &H7FCB0000, &H7F8F8F8F, %DISABLE_TIMER)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    'CALL zSetZorder(hCtrl, %HWND_TOP)
    'CALL zCreateToolTip(hCtrl, "This is a zClockCtrl")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), zCXSYSICON(0,0), zCYSYSICON(0,0), %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", 660+8, 561, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    sImageName = SK_FOLDER() + "StatusBar.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 0, %YMIN_SIZE - imgH, %XMIN_SIZE, imgH, %ID_STATUSBAR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    sImageName = SK_FOLDER() + "Tip.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 6, %YMIN_SIZE - imgH - 1, imgW, imgH, %ID_STATUSTIP, 0)
    CALL ShowWindow(hCtrl, %SW_HIDE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    hCtrl = zStaticLabelEx(gMainWnd, "", 26, %YMIN_SIZE - 19, %XMIN_SIZE - 45, 15, %ID_STATUSMESSAGE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, -1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)

    LOCAL sLensMessage AS STRING
    sLensMessage = "Change the lens"
    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Camera", 24, 70 + 92 + 22, 85, 22, %ID_CAMERA, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetCheckButtonStatus(hCtrl, %TRUE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Gradation", 24, 70 + 92 + 22 * 2, 85, 22, %ID_GRADATION, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Glossy", 24, 70 + 92 + 22 * 3, 85, 22, %ID_GLOSSY, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Reflection", 24, 70 + 92 + 22 * 4, 85, 22, %ID_REFLECTION, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Blue", 24, 70 + 92 + 22 * 5, 85, 22, %ID_BLUE, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Red", 24, 70 + 92 + 22 * 6, 85, 22, %ID_RED, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Enlighten", 24, 70 + 92 + 22 * 7, 85, 22, %ID_ENLIGHTEN, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zRadioButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Bevel", 24, 70 + 92 + 22 * 8, 85, 22, %ID_BEVEL, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetAnchorMode(hCtrl, %ANCHOR_LEFT)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, (sLensMessage))

    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Composited", 24, 471, 90, 22, %ID_COMPOSITED, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetCheckButtonStatus(hCtrl, %TRUE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Enable or Disable the composited mode")

    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Show anim.", 24, 493, 90, 22, %ID_ANIMATION, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Sprite multi-frame")

    sImageName = SK_FOLDER() + "Gem.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    CALL GetWindowRect(gMainWnd, rw)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", ((rw.nRight - rw.nLeft) - imgW) \ 2, 0, imgW, imgH, %ID_Gem, 0)
    '//CALL zSetAnchorMode(hCtrl, %ANCHOR_CENTER_HORZ)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

END SUB

SUB GdimageResize()
'    LOCAL lpr AS RECT, nX, nY, nSizeX, nSizeY AS LONG, rZoomValue AS SINGLE
    CALL GDImageBackground()
'    '// Compute new range
'    CALL GDImageSetZoomRange(%GL_SizeX, %GL_SizeY, nSizeX, nSizeY)
'    rZoomValue = (nSizeX / (%GL_SizeX / grAspect))
'    CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ZOOM), CLNG(rZoomValue * 1000))
'    CALL zSetProperty(zGetMainItem(%ID_TRACK_ZOOM), %TRACK_DEFAULT_VALUE, CLNG(rZoomValue * 1000))
'    CALL ZD_SetObjectScale(%IDS_3DOBJECT, rZoomValue)
'    CALL GetClientRect(gnCtrl, lpr)
'
'    CALL ZD_SetObjectScale(%IDS_3DOBJECT, rZoomValue)
'
'    CALL DisplayZoomValue()

END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
'CALL KillTimer(hWnd, 1)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL GDImageBackground()
       CALL zUpdateWindow(hWnd, 0)
    END IF
'CALL SetTimer(hWnd, 1, 30, %NULL)
END SUB

'// This is the magic place to control what is going on inside of the GDImage graphic container!
FUNCTION GDImageCallBack(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL lpr AS RECT, nRet, nObjectID, x, y, x1, y1, ObjectType, useWidth, useHeight, BoundWidth, BoundHeight AS LONG
    LOCAL x2Div2, y2Div2, useStep, nAngle AS LONG

    nRet = %FALSE ' Do not stop the event processing in GDImage

    nObjectID = ZI_MouseOverObjectID()

    SELECT CASE LONG Msg

    CASE %WM_LBUTTONDOWN
         IF nObjectID THEN
            IF nObjectID > 0 THEN

               '//nSelected is int = ZD_GetObjectSelected(nObjectID)
               ObjectType = ZD_GetObjectType(nObjectID)
               IF (ObjectType = %OBJECT_BITMAP) OR (ObjectType = %OBJECT_TEXTBITMAP) THEN
                  IF gnFocusID <> nObjectID THEN
'//                     CALL GDImageChangeFocus(nObjectID)
                  END IF
               END IF
            END IF
         END IF

    CASE %WM_LBUTTONUP
         IF nObjectID > 0 THEN

            CALL UpdateQualityStatus(%TRUE)
         END IF

    CASE %WM_RBUTTONDOWN

    CASE %WM_MOUSEMOVE
         IF nObjectID > 0 THEN
            IF ZI_IsLButtonDown() THEN

               CALL UpdateQualityStatus(%FALSE)
            ELSE
               IF ZI_IsShiftKeyPressed() = %FALSE THEN CALL UpdateQualityStatus(%TRUE)
            END IF
         END IF

    CASE %WM_KEYDOWN
         nObjectID = ZI_GetObjectFocusID() '// Move the sprite that has the focus
         IF nObjectID > 0 THEN

            IF ZI_IsAnyArrowPressed() THEN
               CALL UpdateQualityStatus(%FALSE)
            END IF

            CALL ZD_GetObjectXY(nObjectID, x, y)
            x1 = x ' Make a copy to keep the orignal x location unchanged
            y1 = y ' Make a copy to keep the orignal y location unchanged
          ' Check accelerator keys to compute the step range
            IF ZI_IsCtrlKeyPressed THEN
               UseStep = 4
               IF ZI_IsShiftKeyPressed THEN UseStep = 16
            ELSEIF ZI_IsShiftKeyPressed THEN
               UseStep = 2
            ELSE
               UseStep = 1
            END IF

            IF ZD_GetObjectScroll(nObjectID) THEN ' If object scroll with the bitmap background
             ' Get the size of the bitmap background
               CALL ZI_GetBitmapSize(ZI_GetBMP(hWnd), useWidth, useHeight)
            ELSE
             ' Get the control client size
               CALL GetClientRect(hWnd, lpr)
               useWidth = lpr.nRight: useHeight = lpr.nBottom
            END IF
          ' Get the sprite object size
            CALL ZD_GetObjectBound(nObjectID, BoundWidth, BoundHeight)

            x2Div2 = (BoundWidth \ 2): y2Div2 = BoundHeight \ 2

            SELECT CASE wParam
            CASE %VK_HOME
                 x1 = 0
            CASE %VK_END
                 x1 = MAX&(useWidth - BoundWidth, 0)
            CASE %VK_PRIOR
                 y1 = 0
            CASE %VK_NEXT
                 y1 = MAX&(useHeight - BoundHeight, 0)
            CASE %VK_LEFT, %VK_NUMPAD4
                 IF x1 > -x2Div2 THEN x1 = MAX&(x1 - UseStep, -x2Div2)
            CASE %VK_UP, %VK_NUMPAD8
                 IF y1 > -y2Div2 THEN y1 = MAX&(y1 - UseStep, -y2Div2)
            CASE %VK_RIGHT, %VK_NUMPAD6
                 IF x1 < useWidth - x2Div2 THEN
                    x1 = MIN&(x1 + UseStep, useWidth - x2Div2)
                 END IF
            CASE %VK_DOWN, %VK_NUMPAD2
                 IF y1 < useHeight - y2Div2 THEN
                 y1 = MIN&(y1 + UseStep, useHeight - y2Div2)
                 END IF
            END SELECT

            IF x <> x1 OR y <> y1 THEN
               x = x1: y = y1
               CALL ZD_MoveLinkedObject(nObjectID, x1, y1, %TRUE)
            END IF
         END IF
    CASE %WM_KEYUP
         IF ZI_IsAnyArrowPressed() = 0 THEN
            CALL UpdateQualityStatus(%TRUE)
         END IF

    CASE %WM_SIZE
         CALL GDImageResize()

    CASE %WM_MOUSEWHEEL
         IF ZI_IsShiftKeyPressed THEN
            CALL UpdateQualityStatus(%FALSE)
         ELSE
            CALL UpdateQualityStatus(%TRUE)
         END IF
    END SELECT

    FUNCTION = nRet
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL hDC, hList, nItem, Img AS LONG
    LOCAL sDataString AS STRING

    IF IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) THEN
       IF ZI_IsLButtonDown() = 0 THEN CALL ShowTip(%FALSE)
    END IF

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COPYDATA

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_TRACK_ZOOM
              CALL UseThisZoom()

         CASE %ID_TRACK_ROTATION
              CALL UseThisAngle()

         CASE %ID_TRACK_BRIGHTNESS
              CALL UseThisBrightness()

         CASE %ID_TRACK_ALPHA
              CALL UseThisAlpha()

         CASE %ID_TRACK_CONTRAST
              CALL UseThisContrast()

         CASE %ID_TRACK_RED
              CALL UseThisRed()

         CASE %ID_TRACK_GREEN
              CALL UseThisGreen()

         CASE %ID_TRACK_BLUE
              CALL UseThisBlue()

         CASE %ID_TRACK_HUE
              CALL UseThisHue()

         CASE %ID_RESET
              CALL GDImageResetImage(gnCtrl, gnFocusID)'//%IDS_3DOBJECT)

         CASE %ID_COMPOSITED
              CALL GDImageBackground()
              CALL ZI_UpdateWindow(gnCtrl, %FALSE)

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_BACKL
              hList = zGetMainItem(%ID_BACK_LIST)
              nItem = ListGetCursel(hList)
              IF nItem > 1 THEN
                 DECR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = ListCount(hList)
                 CALL ListSelectPlus(hList, nItem)
              END IF
              sDataString = ListGetText(hList, nItem)
              Img = zCreateImageFromFile((sDataString))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (sDataString), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)

                 CALL zSplitN(sDataString, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
                 CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))

                 '//CALL ZI_MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

              END IF

         CASE %ID_BTN_BACKR
              hList = zGetMainItem(%ID_BACK_LIST)
              nItem = ListGetCursel(hList)
              IF nItem < ListCount(hList) THEN
                 INCR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = 1
                 CALL ListSelectPlus(hList, nItem)
              END IF
              sDataString = ListGetText(hList, nItem)
              Img = zCreateImageFromFile((sDataString))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (sDataString), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)

                 CALL zSplitN(sDataString, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
                 CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))

                 '//CALL ZI_MakeMultipleTexture (BYVAL VARPTR(mt(LBOUND(mt))), UBOUND(mt) - LBOUND(mt) + 1)

              END IF

         CASE %ID_BTN_HELP

         CASE %ID_ANIMATION
              CALL ZD_SetObjectVisibility(%IDS_ANIMATION, zGetCheckButtonStatus(zGetMainItem(%ID_ANIMATION)))
              IF ZD_IsObjectVisible(%IDS_ANIMATION) THEN
	                IF ZD_GetObjectAlpha(%IDS_3DOBJECT) = 255 THEN
                     CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ALPHA), 200): CALL UseThisAlpha()
                     CALL ZI_UpdateWindow(gnCtrl, 0)
	                END IF
              END IF

              'CALL ZD_SetObjectVisibility(%IDS_BOWL, zGetCheckButtonStatus(zGetMainItem(%ID_ANIMATION)))

         CASE %ID_CAMERA
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Camera.png", %IDS_LENS, %TRUE)
         CASE %ID_GRADATION
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Gradation.png", %IDS_LENS, %TRUE)
         CASE %ID_GLOSSY
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Glossy.png", %IDS_LENS, %TRUE)
         CASE %ID_REFLECTION
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Light.png", %IDS_LENS, %TRUE)
         CASE %ID_BLUE
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Blue.png", %IDS_LENS, %TRUE)
         CASE %ID_RED
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Red.png", %IDS_LENS, %TRUE)
         CASE %ID_ENLIGHTEN
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Enlighten.png", %IDS_LENS, %TRUE)
         CASE %ID_BEVEL
              CALL ZD_SetObjectBitmapFromFile(SK_FOLDER() + "LENS_Bevel.png", %IDS_LENS, %TRUE)

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_TIMER
         CALL RenderAnimation(hWnd)

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB GDImageEnableEvents(BYVAL hGDImageCtrl AS LONG)
    LOCAL lpCallBack AS DWORD
    lpCallBack = CODEPTR(GDImageCallBack)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_RBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEMOVE, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_NCHITTEST, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEWHEEL, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_SIZE, %TRUE)
END SUB

SUB GDImageBackground()
    LOCAL lp AS POINTAPI, rc, lpr AS RECT
    LOCAL hIC, hDC, graphics, nBackground, Img, ImgW, ImgH, xP, yP, xS, yS, bmW, bmH, CtrlW, CtrlH, bBitmapFound AS LONG

    CALL GetWindowRect(gnCtrl, lpr)
    lp.x = lpr.nLeft: lp.y = lpr.nTop
    CALL ScreenToClient(gMainWnd, lp)
    IF zGetCheckButtonStatus(zGetMainItem(%ID_COMPOSITED)) THEN

       CALL GetClientRect(gMainWnd, rc)
       CtrlW = lpr.nRight - lpr.nLeft
       CtrlH = lpr.nBottom - lpr.nTop
       nBackground = ZD_GetObjectBitmap(%ID_BACKGROUND)
       IF nBackground THEN
          bBitmapFound = -1
          CALL ZI_GetBitmapSize(nBackground, bmW, bmH)
          IF bmW < CtrlW OR bmH < CtrlH THEN bmW = 0: bmH = 0
       END IF
       IF bmW THEN
          hIC = zDisplayDC()
          hDC = CreateCompatibleDC(hIC)
          CALL SelectObject(hDC, nBackground)
          CALL DeleteDC(hIC)
       ELSE
          '// Use default 1400 x 900
          IF CtrlW > 1400 OR CtrlH > 900 THEN
             hDC = ZI_Create32bitDC(CtrlW, CtrlH, &HFF000000&)
          ELSE
             hDC = ZI_Create32bitDC(1400, 900, &HFF000000&)
          END IF
       END IF

       nBackground = ZI_GetBitmapFromDC(hDC)
       IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, 0)
          CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, 0)
          Img = zGetProperty(gMainWnd, %FORM_Center): CALL zGetImageSize(Img, ImgW, ImgH)
          CALL zComputeAspect(ImgW, ImgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
         '// Set up stretching QualityMode
          CALL GdipSetInterpolationMode(graphics, 2)
          CALL GdipDrawImageRectRectI(graphics, Img, xP - lp.x, yP - lp.y, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, 0)
          CALL ZD_DrawBitmapToCtrl(gnCtrl, 0, 0, nBackground, &HFFFFFFFF, %ID_BACKGROUND, %ZS_VISIBLE)
          CALL GdipDeleteGraphics(graphics)

          CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM) '// Make sure the background is at the bottom of z-order
          CALL ZD_SetObjectLocked(%ID_BACKGROUND, %TRUE)

       END IF
       IF hDC THEN CALL DeleteDC(hDC)
    ELSE
       CALL ZI_SetProperty(gnCtrl, %ZI_GradientTop, RGB(0,0,0))
       CALL ZI_SetProperty(gnCtrl, %ZI_GradientBottom, RGB(128,128,128))
       IF ZD_IsObjectVisible(%ID_BACKGROUND) THEN ZD_SetObjectVisibility(%ID_BACKGROUND, %FALSE)
    END IF

END SUB

SUB GDImageSetZoomRange(BYVAL bmW AS LONG, BYVAL bmH AS LONG, xSize AS LONG, ySize AS LONG)
    LOCAL lpr AS RECT, xPos, yPos AS LONG
    CALL GetClientRect(gnCtrl, lpr)
    CALL ZI_Iconise(bmW, bmH, lpr.nRight, lpr.nBottom, xPos, yPos, xSize, ySize)
    CALL zSetTrackMinMax(zGetMainItem(%ID_TRACK_ZOOM), CLNG((xSize / bmW) * 128), 1500)
END SUB

SUB DisplayZoomValue()
    LOCAL sLabel AS STRING
    sLabel = EXTRACT$(zGetCTLText(zGetMainItem(%ID_LIB_ZOOM)), " ") + USING$(" #.##", ZD_GetObjectScale(gnFocusID))
    CALL zSetCTLText(zGetMainItem(%ID_LIB_ZOOM), (sLabel))
END SUB
SUB UseThisZoom()
    LOCAL nCtrl AS LONG, rZoomValue AS SINGLE
    CALL UpdateQualityStatus(NOT ZI_IsLButtonDown())

    CALL DisplayMessageTip()

    rZoomValue = zGetTrackValue(zGetMainItem(%ID_TRACK_ZOOM)) / 1000
    IF rZoomValue <> grWasZoom THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectScale(gnFocusID, rZoomValue)
ZD_SetObjectScale(%IDS_BORDER, rZoomValue)
ZD_SetObjectScale(%IDS_LENS, rZoomValue)
ZD_SetObjectScale(%IDS_ANIMATION, rZoomValue)
       CALL DisplayZoomValue()

       CALL ZI_UpdateWindow(nCtrl, %FALSE)
    END IF
    grWasZoom = rZoomValue
END SUB

SUB DisplayRotationAngle()
    LOCAL sLabel AS STRING
    sLabel = EXTRACT$(zGetCTLText(zGetMainItem(%ID_LIB_ROTATION)), " ") + STR$(ZD_GetObjectAngle(gnFocusID))+ ""
    CALL zSetCTLText(zGetMainItem(%ID_LIB_ROTATION), (sLabel))
END SUB
SUB UseThisAngle()
    LOCAL nCtrl, nAngle AS LONG
    CALL UpdateQualityStatus(NOT ZI_IsLButtonDown())

    CALL DisplayMessageTip()

    nAngle = zGetTrackValue(zGetMainItem(%ID_TRACK_ROTATION)) + 180: IF nAngle > 359 THEN nAngle = nAngle - 360
    IF nAngle <> gnWasAngle THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectAngle(gnFocusID, nAngle, %FALSE)'TRUE)
       CALL DisplayRotationAngle()

    END IF
    gnWasAngle = nAngle
END SUB

SUB DisplayThisValue(BYVAL nID AS LONG)
    LOCAL sLabel AS STRING
    sLabel = EXTRACT$(zGetCTLText(zGetMainItem(nID)), " ") + USING$(" #.##", (zGetTrackValue(zGetMainItem(nID - 1)) + 1) / 128)
    CALL zSetCTLText(zGetMainItem(nID), (sLabel))
END SUB

SUB DisplayBrightnessValue()
    CALL DisplayThisValue(%ID_LIB_BRIGHTNESS)
END SUB
SUB UseThisBrightness()
    LOCAL nCtrl, nBrightness AS LONG
    'CALL DisplayMessageTip()
    nBrightness = zGetTrackValue(zGetMainItem(%ID_TRACK_BRIGHTNESS))
    IF nBrightness <> gnWasBrightness THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectBrightness(gnFocusID, nBrightness, %TRUE)
       CALL DisplayBrightnessValue()
    END IF
    gnWasBrightness = nBrightness
END SUB

SUB DisplayContrastValue()
    CALL DisplayThisValue(%ID_LIB_CONTRAST)
END SUB
SUB UseThisContrast()
    LOCAL nCtrl, nContrast AS LONG
    'CALL DisplayMessageTip()
    nContrast = zGetTrackValue(zGetMainItem(%ID_TRACK_CONTRAST))
    IF nContrast <> gnWasContrast THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectContrast(gnFocusID, nContrast, %TRUE)
       CALL DisplayContrastValue()
    END IF
    gnWasContrast = nContrast
END SUB

SUB UseThisAlpha()
    LOCAL nCtrl, nAlpha AS LONG
    CALL DisplayMessageTip()
    nAlpha = zGetTrackValue(zGetMainItem(%ID_TRACK_ALPHA))
    IF nAlpha <> gnWasAlpha THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectAlpha(gnFocusID, nAlpha, %TRUE)
    END IF
    gnWasAlpha = nAlpha
END SUB

SUB DisplayRedValue()
    CALL DisplayThisValue(%ID_LIB_RED)
END SUB
SUB UseThisRed()
    LOCAL nCtrl, nRed AS LONG
    'CALL DisplayMessageTip()
    nRed = zGetTrackValue(zGetMainItem(%ID_TRACK_RED))
    IF nRed <> gnWasRed THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectRed(gnFocusID, nRed, %TRUE)
       CALL DisplayRedValue()
    END IF
    gnWasRed = nRed
END SUB

SUB DisplayGreenValue()
    CALL DisplayThisValue(%ID_LIB_GREEN)
END SUB
SUB UseThisGreen()
    LOCAL nCtrl, nGreen AS LONG
    'CALL DisplayMessageTip()
    nGreen = zGetTrackValue(zGetMainItem(%ID_TRACK_GREEN))
    IF nGreen <> gnWasGreen THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectGreen(gnFocusID, nGreen, %TRUE)
       CALL DisplayGreenValue()
    END IF
    gnWasGreen = nGreen
END SUB

SUB DisplayBlueValue()
    CALL DisplayThisValue(%ID_LIB_BLUE)
END SUB
SUB UseThisBlue()
    LOCAL nCtrl, nBlue AS LONG
    'CALL DisplayMessageTip()
    nBlue = zGetTrackValue(zGetMainItem(%ID_TRACK_BLUE))
    IF nBlue <> gnWasBlue THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectBlue(gnFocusID, nBlue, %TRUE)
       CALL DisplayBlueValue()
    END IF
    gnWasBlue = nBlue
END SUB

SUB DisplayHueValue()
    CALL DisplayThisValue(%ID_LIB_HUE)
END SUB
SUB UseThisHue()
    LOCAL nCtrl, nHue AS LONG
    'CALL DisplayMessageTip()
    nHue = zGetTrackValue(zGetMainItem(%ID_TRACK_HUE))
    IF nHue <> gnWasHue THEN
       nCtrl = ZD_GetObjectParent(gnFocusID)
       '// Make sure to disable the crop rectangle if any
       '// On s'assure que le mode "Dlimite section" est dsactiv
       IF ZI_GetToolCropStatus(nCtrl) THEN ZI_DisableCropRectangle(nCtrl)

       CALL ZD_SetObjectHue(gnFocusID, nHue, %TRUE)
       CALL DisplayHueValue()
    END IF
    gnWasHue = nHue
END SUB

SUB UpdateQualityStatus(BYVAL bQuality AS LONG)
    LOCAL nInterpolation AS LONG
    IF bQuality THEN
       nInterpolation = 2 ' %InterpolationModeHighQuality
    ELSE
       nInterpolation = 0 ' %InterpolationModeDefault
    END IF
    IF ZD_GetObjectQuality(%IDS_3DOBJECT) <> nInterpolation THEN
       CALL ZD_SetObjectQuality(%IDS_3DOBJECT, nInterpolation, %TRUE)
    END IF
END SUB

SUB GDImageResetImage(BYVAL nGDImageCtrl AS LONG, BYVAL nID_IMAGE AS LONG)
    LOCAL stZ AS ZOBJECT

    '// Get the GDImage objectproperties
    CALL ZD_GetObjectProperties(nID_IMAGE, stZ)

    '// Restore default zoom value
    stZ.scale = 1
    CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ZOOM), CLNG(stZ.scale * 1000))
    CALL UseThisZoom()

    '// Restore the default rotation angle
    gnWasAngle = 180: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ROTATION), gnWasAngle): stZ.angle = 0
    '// Restore default opacity
    gnWasAlpha = 255: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_ALPHA), gnWasAlpha): stZ.useARGB = ZD_ColorARGB(255, 0)
    '// Restore the default Brightness
    gnWasBrightness = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BRIGHTNESS), gnWasBrightness): stZ.brightness = 0
    '// Restore the default Contrast
    gnWasContrast = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_CONTRAST), gnWasContrast): stZ.contrast = 0
    '// Restore the default Red level
    '//IF ZD_GetObjectRed(nID_IMAGE) <> 0 THEN
    gnWasRed = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_RED), gnWasRed): stZ.red = 0
    '// Restore the default Green level
    gnWasGreen = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_GREEN), gnWasGreen): stZ.green = 0
    '// Restore the default Blue level
    gnWasBlue = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_BLUE), gnWasBlue): stZ.blue = 0
    '// Restore the default Hue level
    gnWasHue = 127: CALL zSetTrackValue(zGetMainItem(%ID_TRACK_HUE), gnWasHue): stZ.Hue = 0

    gnSeedAngle = 0 '// Compass rotation
    gnPrevAngle = 0 '// Compass rotation

    '// Update the GDImage objectproperties
    CALL ZD_SetObjectProperties(nID_IMAGE, stZ)

    CALL DisplayZoomValue()
    CALL DisplayRotationAngle()
    CALL DisplayBrightnessValue()
    CALL DisplayContrastValue()
    CALL DisplayRedValue()
    CALL DisplayGreenValue()
    CALL DisplayBlueValue()
    CALL DisplayHueValue()
END SUB

SUB ShowTip(BYVAL bShowHide AS LONG)
    LOCAL nUseState AS LONG, sMessage AS STRING
    IF bShowHide THEN
       nUseState = %SW_SHOW
       sMessage = "TIP: clic with the right mouse button to restore the default value while hover a slider."
    ELSE
       nUseState = %SW_HIDE
       sMessage = ""
    END IF
    CALL ShowWindow(zGetMainItem(%ID_STATUSTIP), nUseState)
    CALL zSetCTLText(zGetMainItem(%ID_STATUSMESSAGE), (sMessage))
END SUB

SUB DisplayMessageTip()
    IF ZI_IsLButtonDown() AND IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) = 0 THEN CALL ShowTip(%TRUE)
END SUB

'// This is the callback being used for all the animations
SUB RenderAnimation(BYVAL hWnd AS DWORD)', BYVAL hGLDC AS LONG, BYVAL hGLRC AS LONG)
    STATIC Flip AS LONG

    '// Draw active frame to new memory DC
    Flip = NOT Flip
    IF Flip THEN
'       // Draw the OpenGL object
        CALL DrawObject3D(GL_GLDC(), GL_GLRC() )
'       // Alphablend the OpenGL animation hover the background
        CALL GL_AlphaBlend( GLmemDC() , GL_GLDC() )
'       // Paint the resulting bitmap to our window
        CALL ZD_ReplaceObjectBitmap(ZI_CreateBitmapFromImage(zBitmapToImage( GLmemDC() )), %IDS_3DOBJECT, %True)
    ELSE'
        CALL RedrawJumper(hWnd)
        'CALL RedrawBowl(hWnd)
        CALL RedrawClock(hWnd)
    END IF

END SUB

'// Update the clock control
SUB RedrawClock(BYVAL hWnd AS LONG)
    STATIC sT AS DWORD
    LOCAL rc AS RECT, p AS POINTAPI
    IF sT = 0 THEN sT = GetTickCount() + 1000
    IF GetTickCount() > sT THEN
       sT = 0
       '// Invalidate rectangle to paint the clock
       CALL GetWindowRect(zGetMainItem(%ID_CLOCK), rc)
       p.X = rc.nLeft: p.Y = rc.nTop: CALL ScreenToClient(hWnd, p)
       CALL SetRect(rc, p.X, p.Y, p.X + (rc.nRight - rc.nLeft), p.Y + (rc.nBottom - rc.nTop))
       CALL InvalidateRect(hWnd, rc, 0)
    END IF
END SUB

'// Display the animated jumper
SUB RedrawJumper(BYVAL hWnd AS LONG)
    STATIC stCount AS LONG

    IF ZD_IsObjectVisible(%IDS_ANIMATION) THEN
       IF ZD_GetObjectAlpha(%IDS_3DOBJECT) = 255 THEN
          CALL zSetCheckButtonStatus(zGetMainItem(%ID_ANIMATION), %FALSE)
          CALL ZD_SetObjectVisibility(%IDS_ANIMATION, zGetCheckButtonStatus(zGetMainItem(%ID_ANIMATION)))
       ELSE
          RANDOMIZE(TIMER)
          INCR stCount
          IF stCount > ZD_GetObjectFrameCount(%IDS_ANIMATION) THEN 
             stCount = 1
             IF RND(1,3) = 2 THEN CALL ZD_SetObjectFlipMode(%IDS_ANIMATION, %ZD_Reverse)
          END IF
          CALL ZD_SetObjectFrameToUse(%IDS_ANIMATION, stCount, %FALSE)
       END IF
    END IF

END SUB

''// Display the animated bowl
'SUB RedrawBowl(BYVAL hWnd AS LONG)
'    STATIC stCount AS LONG
'    IF ZD_IsObjectVisible(%IDS_BOWL) THEN
'       RANDOMIZE(TIMER)
'       INCR stCount
'       IF stCount > ZD_GetObjectFrameCount(%IDS_BOWL) THEN stCount = 1
'       CALL ZD_SetObjectFrameToUse(%IDS_BOWL, stCount, %FALSE)
'    END IF
'END SUB

%GL_DEPTH_BUFFER_BIT                            = &H00000100
%GL_COLOR_BUFFER_BIT                            = &H00004000
DECLARE SUB glClear LIB "opengl32.dll" ALIAS "glClear" (BYVAL mask AS DWORD)
DECLARE SUB gluPerspective LIB "glu32.dll" ALIAS "gluPerspective" (BYVAL fovy#, BYVAL aspect#, BYVAL zNear#, BYVAL zFar AS DOUBLE)
DECLARE SUB glClearColor LIB "opengl32.dll" ALIAS "glClearColor" (BYVAL red AS SINGLE, BYVAL green AS SINGLE, BYVAL blue AS SINGLE, BYVAL alpha AS SINGLE)
DECLARE SUB glLoadIdentity LIB "opengl32.dll" ALIAS "glLoadIdentity" ()
DECLARE SUB glTranslatef LIB "opengl32.dll" ALIAS "glTranslatef" (BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glRotatef LIB "opengl32.dll" ALIAS "glRotatef" (BYVAL angle AS SINGLE, BYVAL x AS SINGLE, BYVAL y AS SINGLE, BYVAL z AS SINGLE)
DECLARE SUB glColor4ub LIB "opengl32.dll" ALIAS "glColor4ub" (BYVAL red AS BYTE, BYVAL green AS BYTE, BYVAL blue AS BYTE, BYVAL alpha AS BYTE)

DECLARE FUNCTION wglMakeCurrent LIB "OPENGL32.DLL" ALIAS "wglMakeCurrent" (BYVAL hdc AS DWORD, BYVAL hglrc AS DWORD) AS LONG

'// This is the place where we render the OpenGL object,
'// that will be displayed as the %IDS_3DOBJECT.
SUB DrawObject3D(BYVAL GLDC AS LONG, BYVAL GLRC AS LONG) ' See MSDN documentation for the use of the OpenGL API

    STATIC xrot AS SINGLE, yrot AS SINGLE, zrot AS SINGLE

    '// Very important do not change: 0.015625 (it used to detect region)
    CALL glClearColor(0.015625, 0.0, 0.015625, 1.0) '// RGB(4,0,4) is our transparent color
    CALL glClear(%GL_COLOR_BUFFER_BIT OR %GL_DEPTH_BUFFER_BIT)

    CALL glLoadIdentity()

    'CALL gluPerspective(38.0, 1.0, 1.0, 100.0)
    CALL gluPerspective(17.5, 1.0, 1.0, 100.0)

    CALL glTranslatef(0.0, 0.0, -5.50)

    CALL glRotatef(yrot, 0.0, 1.0, 0.0)                             ' Rotate On The Y Axis
    yrot += 2'2'3 ' Y Axis Rotation

    CALL GL_DrawSphere(1, mt(1).Texture)


    CALL wglMakeCurrent(GLDC, GLRC)

END SUB

